#define cntx 3.2 
#define cnty 2.4 
#define cntz 2.4
// grid dimension is : [((imax-1)*4+1) * ((jmax-1)*4+1)] with ghost grids and [((imax-1)*4-1) * ((jmax-1)*4-1)] without ghost grids
// domain dimension is : [{-dxValue ~ ((imax-1)*4-1)*dxValue} * {-dyValue ~ ((jmax-1)*4-1)*dyValue}]  with ghost grids 
//[{0 ~ ((imax-1)*4-2)*dxValue} * {0 ~ ((jmax-1)*4-2)*dyValue}]  without ghost grids 
#define imax 24 
#define jmax 50 
#define kmax 24
//#define imax 4 
//#define jmax 3 
#define dxValue 0.1
#define dyValue 0.1
#define dzValue 0.1
//#define dxValue 0.1
//#define dyValue 0.1
#define MaxGridShift 10 // maximum grid shift in one time step // THIS MAY CAUSE SOME PROBLEM IN CASE WITH PERIODIC BC, SINCE IT REQUIRES THE BOUNDARY NODES HAVING SOME DISTANCE FROM THE GEOMETRY
#define nmpcrcl 180
#define CD (nmpcrcl*nmpcrcl)
#define rr 0.5
#define PI 3.1415926535
#define inlet 1.0
#define mu (double)(1./50.) 
#define dt 0.005
#define timestpNum 20000 
#define outputInt 100 

#define MirrorVgridBC 0 
#define xg 2 
#define yg 2
#define zg 2
#define xb 2
#define yb 2
#define zb 2

typedef enum {DIRICHLET, NEUMANN} BCType;

typedef struct {
  int l;
  int r;
  int t;
  int b;
  int f;
  int a; // aft = back
} VicinityGrid; // Grid in vicinity

typedef struct {
  double x;
  double y;
  double z;
} ThreeDGrid;


typedef struct {
  // x-direction
  int lgEnd; // the max number of left ghosted nodes
  int rgStr; // the min number of right ghosted nodes
  int lbEnd; // the max number of left boundary nodes
  int rbStr; // the min number of right boundary nodes
  int lcStr; // the min number of computational nodes
  int rcEnd; // the max number of computational nodes

  // y-direction
  int bgEnd; // the max number of bottom ghosted nodes
  int tgStr; // the min number of top ghosted nodes
  int bbEnd; // the max number of bottom boundary nodes
  int tbStr; // the min number of top boundary nodes
  int bcStr; // the min number of computational nodes
  int tcEnd; // the max number of computational nodes

  // z-direction
  int agEnd; // the max number of bottom ghosted nodes
  int fgStr; // the min number of top ghosted nodes
  int abEnd; // the max number of bottom boundary nodes
  int fbStr; // the min number of top boundary nodes
  int acStr; // the min number of computational nodes
  int fcEnd; // the max number of computational nodes

} NodeIndex;

typedef struct {
  int lBC;
  int rBC;
  int bBC;
  int tBC;
  int aBC;
  int fBC;

} LocalBC;

typedef struct {
  int l;
  int r;
  int b;
  int t;
  int a;
  int f;
} NeighborRank;

typedef struct {
  int L1st;
  int L2nd;
  int R1st;
  int R2nd;
  int T1st;
  int T2nd;
  int B1st;
  int B2nd;
  int F1st;
  int F2nd;
  int A1st;
  int A2nd;
} CommunicationTag;
